Imports PluginInterface
Imports System.Timers
Imports System.Collections.Generic

''' <summary>
''' Plugin2
''' </summary>
Public Class Plugin
	Implements IPlugin
	' <-- See how we inherited the IPlugin interface?
	'option variables
	Public myOptions As pluginOptions
	Private mainCtl As ctlMain


	Public Sub New()
		'
		' TODO: Add constructor logic here
		'
		myOptions = New pluginOptions()


		myMainInterface = New ctlMain(myOptions)


		mainCtl = DirectCast(myMainInterface, ctlMain)
	End Sub


	'Declarations of all our internal plugin variables
	'VoxCommando expects these to be here so don't remove them.

	#Region "stuff to edit for new plugins"
	'Declarations of all our internal plugin variables
	'VoxCommando expects these to be here so don't remove them.
	Private myName As String = System.Reflection.Assembly.GetExecutingAssembly().GetName().Name
	Private myDescription As String = "Sends and receives UDP packets" & vbCr & vbLf & "offers more control than the eventGhost commands included in VoxCommando's default actions."

	Private myGenEvents As Boolean = True
	Private myAuthor As String = "probably James Richards"
	Private myVersion As String = System.Reflection.Assembly.GetExecutingAssembly().GetName().Version.ToString()


	#End Region


	#Region "plugin stuff don't touch"

	Private myHost As IPluginHost = Nothing
	Private myMainInterface As System.Windows.Forms.UserControl

	Public ReadOnly Property Name() As String Implements IPlugin.Name
		Get
			Return myName
		End Get
	End Property
	Public ReadOnly Property Description() As String Implements IPlugin.Description
		Get
			Return myDescription
		End Get
	End Property

	Public ReadOnly Property GenEvents() As Boolean
		Get
			Return myGenEvents
		End Get
	End Property

	Public ReadOnly Property Author() As String Implements IPlugin.Author
		Get
			Return myAuthor
		End Get
	End Property

	Public Property Host() As IPluginHost Implements IPlugin.Host
		Get
			Return myHost
		End Get
		Set
			myHost = value
			mainCtl = DirectCast(myMainInterface, ctlMain)
			mainCtl.PluginHost = Me.Host
			mainCtl.Plugin = Me
		End Set
	End Property

	Public ReadOnly Property Version() As String Implements IPlugin.Version
		Get
			Return myVersion
		End Get
	End Property

	Public ReadOnly Property MainInterface() As System.Windows.Forms.UserControl Implements IPlugin.MainInterface
		Get
			Return myMainInterface
		End Get
	End Property



	#End Region


	Public Sub Initialize() Implements IPlugin.Initialize

		'This is the first Function called by the host...
		'Put anything needed to start with here first

		'e.g.    udpListener.myHost = this.Host;
	End Sub

	''' <summary>
	''' This is the main method called by VoxCommando.  All actions go through here
	''' </summary>
	''' <param name="parsedActions">an array of strings parsedActions[0] is the plugin name</param>
	''' <param name="parsedParams">an array of strings representing our action parameters</param>
	''' <returns>an actionResult</returns>
	Public Function doAction(parsedActions As String(), parsedParams As String()) As actionResult Implements IPlugin.doAction
		Dim thisAR As New actionResult()

		' Putting the whole thing in a try-catch ensures we won't bring VC down even if the macro has bad action code.
		' the catch will return the error code which shows up in the VC history window
		Try
			'get the first action following the plugin name
			'example action:  xbmc.send  >>>   parsedActions[1] is "send"
			Dim actionType As String = parsedActions(1)


			'Do stuff based on the action                
			'   use all lowercase in case strings below

			Dim port As Integer = myOptions.defaultPort

			Select Case actionType.ToLower()
				Case "test"
					thisAR = testAction(parsedParams)
					Exit Select
				Case "testevent"
					thisAR = testEvent(parsedParams)
					Exit Select
				Case Else


					'not a command we recognize
					thisAR.setError("unknown plugin action")
					Exit Select
				'thisAR.setSuccess("good");

			End Select
		Catch err As Exception
			thisAR.setError(err.ToString())
		End Try
		Return thisAR
	End Function



	#Region "other methods"
	' put other methods here.  perhaps called by 'doAction'

	Private Function testAction(parsedParams As String()) As actionResult
		Dim thisAR As New actionResult()
		thisAR.setSuccess("test action success, # params: " & parsedParams.Length)

		Return thisAR
	End Function

	Private Function testEvent(parsedParams As String()) As actionResult
		myHost.log("testing event call")
		Dim eventPayloads As List(Of [String]) = New List(Of String)() From { _
			"test payload1", _
			"test payload2" _
		}
		myHost.triggerEvent("SamplePlugin.TestEvent", eventPayloads)
		Dim thisAR As New actionResult()
		thisAR.setSuccess("test action success, sent event")

		Return thisAR
	End Function


	#End Region

	Public Sub Dispose() Implements IPlugin.Dispose
		'cleanup code when program is stopped 

	End Sub
End Class


