Imports System.Collections.Generic
Imports System.Text
Imports System.Xml

''' <summary>
''' options will be loaded automatically when this is created
''' </summary>
Public Class pluginOptions
	'define varialbe to hold the options you need to keep track of here
	Public defaultIP As String
	Public defaultPort As Int32


	'this is used to load and save options to the correct folder
	Private strPluginPath As String

	Public Sub New()
		'set default values
		defaultIP = "255.255.255.255"
		defaultPort = 8760


		'find the correct folder and store it for later use by the load and save methods
		strPluginPath = System.IO.Path.GetDirectoryName(System.Reflection.Assembly.GetExecutingAssembly().Location) & "\Options.xml"
		If System.IO.File.Exists(strPluginPath) Then
			loadOptionsFromXml()
		End If
	End Sub

	''' <summary>
	''' saves all our options
	''' must create a case for each value to load
	''' </summary>
	Public Sub loadOptionsFromXml()
		Dim myXmlDocument As New XmlDocument()
		myXmlDocument.Load(strPluginPath)

		Dim rootnode As XmlNode
		Dim nextnode As XmlNode
		rootnode = myXmlDocument.DocumentElement
		nextnode = rootnode.NextSibling

		For Each majorNode As XmlNode In rootnode.SelectNodes("Option")
			Dim minorNodeName As String = majorNode.Attributes("name").Value
			Dim minorNodeValue As String = majorNode.Attributes("value").Value
			Select Case majorNode.Attributes("name").Value
				Case "defaultIP"
					defaultIP = minorNodeValue
					Exit Select
				Case "defaultPort"
					defaultPort = Convert.ToInt32(minorNodeValue)
					Exit Select
				Case Else

					'
					Exit Select
			End Select
		Next

		myXmlDocument = Nothing
	End Sub

	Public Sub saveOptionsToXml()
		' Create the XML document and write the comments and root node "AllOptions"
		Dim writer As New XmlTextWriter(strPluginPath, New System.Text.ASCIIEncoding())
		writer.Formatting = Formatting.Indented
		writer.Indentation = 4
		writer.WriteStartDocument()
        writer.WriteComment("options for VoxCommando / <plugin name goes here>.")

		writer.WriteStartElement("Options")
		If True Then
			saveOptionNodeToXml(writer, "defaultIP", defaultIP)
			saveOptionNodeToXml(writer, "defaultPort", defaultPort.ToString())
		End If
		writer.WriteEndElement()


		'#Region "Close Up the XML document"
		'counterpart to WriteStartDocument command
		writer.WriteEndDocument()
		writer.Flush()
		writer.Close()
		'#End Region
	End Sub

	Private Sub saveOptionNodeToXml(writer As XmlTextWriter, nodename As String, nodevalue As String)
		writer.WriteStartElement("Option")
		writer.WriteAttributeString("name", nodename)
		writer.WriteAttributeString("value", nodevalue)
		writer.WriteEndElement()
	End Sub
End Class
